diff --git a/drivers/net/mlx5/linux/mlx5_verbs.c b/drivers/net/mlx5/linux/mlx5_verbs.c
index 7d623c8..5eb556e 100644
--- a/drivers/net/mlx5/linux/mlx5_verbs.c
+++ b/drivers/net/mlx5/linux/mlx5_verbs.c
@@ -89,6 +89,27 @@
 		.flags_mask = IBV_WQ_FLAGS_CVLAN_STRIPPING,
 		.flags = vlan_offloads,
 	};
+
+	return mlx5_glue->modify_wq(rxq_obj->wq, &mod);
+}
+
+/**
+ * Modifies the attributes for the specified WQ.
+ *
+ * @param rxq_obj
+ *   Verbs Rx queue object.
+ *
+ * @return
+ *   0 on success, a negative errno value otherwise and rte_errno is set.
+ */
+static int
+mlx5_ibv_modify_wq(struct mlx5_rxq_obj *rxq_obj, bool is_start)
+{
+	struct ibv_wq_attr mod = {
+		.attr_mask = IBV_WQ_ATTR_STATE,
+		.wq_state = is_start ? IBV_WQS_RDY : IBV_WQS_RESET,
+	};
+
 	return mlx5_glue->modify_wq(rxq_obj->wq, &mod);
 }
 
@@ -273,7 +294,6 @@
 	struct mlx5_rxq_data *rxq_data = (*priv->rxqs)[idx];
 	struct mlx5_rxq_ctrl *rxq_ctrl =
 		container_of(rxq_data, struct mlx5_rxq_ctrl, rxq);
-	struct ibv_wq_attr mod;
 	struct mlx5_rxq_obj *tmpl = rxq_ctrl->obj;
 	struct mlx5dv_cq cq_info;
 	struct mlx5dv_rwq rwq;
@@ -335,11 +355,7 @@
 		goto error;
 	}
 	/* Change queue state to ready. */
-	mod = (struct ibv_wq_attr){
-		.attr_mask = IBV_WQ_ATTR_STATE,
-		.wq_state = IBV_WQS_RDY,
-	};
-	ret = mlx5_glue->modify_wq(tmpl->wq, &mod);
+	ret = mlx5_ibv_modify_wq(tmpl, true);
 	if (ret) {
 		DRV_LOG(ERR,
 			"Port %u Rx queue %u WQ state to IBV_WQS_RDY failed.",
@@ -424,26 +440,6 @@
 	return -rte_errno;
 }
 
-/**
- * Modifies the attributes for the specified WQ.
- *
- * @param rxq_obj
- *   Verbs Rx queue object.
- *
- * @return
- *   0 on success, a negative errno value otherwise and rte_errno is set.
- */
-static int
-mlx5_ibv_modify_wq(struct mlx5_rxq_obj *rxq_obj, bool is_start)
-{
-	struct ibv_wq_attr mod = {
-		.attr_mask = IBV_WQ_ATTR_STATE,
-		.wq_state = is_start ? IBV_WQS_RDY : IBV_WQS_RESET,
-	};
-
-	return mlx5_glue->modify_wq(rxq_obj->wq, &mod);
-}
-
 struct mlx5_obj_ops ibv_obj_ops = {
 	.rxq_obj_modify_vlan_strip = mlx5_rxq_obj_modify_wq_vlan_strip,
 	.rxq_obj_new = mlx5_rxq_ibv_obj_new,
diff --git a/drivers/net/mlx5/mlx5_devx.c b/drivers/net/mlx5/mlx5_devx.c
index e577e38..07922c2 100644
--- a/drivers/net/mlx5/mlx5_devx.c
+++ b/drivers/net/mlx5/mlx5_devx.c
@@ -47,6 +47,31 @@
 }
 
 /**
+ * Modify RQ using DevX API.
+ *
+ * @param rxq_obj
+ *   DevX Rx queue object.
+ *
+ * @return
+ *   0 on success, a negative errno value otherwise and rte_errno is set.
+ */
+static int
+mlx5_devx_modify_rq(struct mlx5_rxq_obj *rxq_obj, bool is_start)
+{
+	struct mlx5_devx_modify_rq_attr rq_attr;
+
+	memset(&rq_attr, 0, sizeof(rq_attr));
+	if (is_start) {
+		rq_attr.rq_state = MLX5_RQC_STATE_RST;
+		rq_attr.state = MLX5_RQC_STATE_RDY;
+	} else {
+		rq_attr.rq_state = MLX5_RQC_STATE_RDY;
+		rq_attr.state = MLX5_RQC_STATE_RST;
+	}
+	return mlx5_devx_cmd_modify_rq(rxq_obj->rq, &rq_attr);
+}
+
+/**
  * Release the resources allocated for an RQ DevX object.
  *
  * @param rxq_ctrl
@@ -101,24 +126,6 @@
 }
 
 /**
- * Release an Rx hairpin related resources.
- *
- * @param rxq_obj
- *   Hairpin Rx queue object.
- */
-static void
-mlx5_rxq_obj_hairpin_release(struct mlx5_rxq_obj *rxq_obj)
-{
-	struct mlx5_devx_modify_rq_attr rq_attr = { 0 };
-
-	MLX5_ASSERT(rxq_obj);
-	rq_attr.state = MLX5_RQC_STATE_RST;
-	rq_attr.rq_state = MLX5_RQC_STATE_RDY;
-	mlx5_devx_cmd_modify_rq(rxq_obj->rq, &rq_attr);
-	claim_zero(mlx5_devx_cmd_destroy(rxq_obj->rq));
-}
-
-/**
  * Release an Rx DevX queue object.
  *
  * @param rxq_obj
@@ -130,7 +137,8 @@
 	MLX5_ASSERT(rxq_obj);
 	MLX5_ASSERT(rxq_obj->rq);
 	if (rxq_obj->type == MLX5_RXQ_OBJ_TYPE_DEVX_HAIRPIN) {
-		mlx5_rxq_obj_hairpin_release(rxq_obj);
+		mlx5_devx_modify_rq(rxq_obj, false);
+		claim_zero(mlx5_devx_cmd_destroy(rxq_obj->rq));
 	} else {
 		MLX5_ASSERT(rxq_obj->devx_cq);
 		claim_zero(mlx5_devx_cmd_destroy(rxq_obj->rq));
@@ -144,31 +152,6 @@
 }
 
 /**
- * Modify RQ using DevX API.
- *
- * @param rxq_obj
- *   DevX Rx queue object.
- *
- * @return
- *   0 on success, a negative errno value otherwise and rte_errno is set.
- */
-static int
-mlx5_devx_modify_rq(struct mlx5_rxq_obj *rxq_obj, bool is_start)
-{
-	struct mlx5_devx_modify_rq_attr rq_attr;
-
-	memset(&rq_attr, 0, sizeof(rq_attr));
-	if (is_start) {
-		rq_attr.rq_state = MLX5_RQC_STATE_RST;
-		rq_attr.state = MLX5_RQC_STATE_RDY;
-	} else {
-		rq_attr.rq_state = MLX5_RQC_STATE_RDY;
-		rq_attr.state = MLX5_RQC_STATE_RST;
-	}
-	return mlx5_devx_cmd_modify_rq(rxq_obj->rq, &rq_attr);
-}
-
-/**
  * Get event for an Rx DevX queue object.
  *
  * @param rxq_obj
@@ -563,7 +546,6 @@
 	struct mlx5_rxq_ctrl *rxq_ctrl =
 		container_of(rxq_data, struct mlx5_rxq_ctrl, rxq);
 	struct mlx5_rxq_obj *tmpl = rxq_ctrl->obj;
-	struct mlx5_devx_modify_rq_attr rq_attr = { 0 };
 	int ret = 0;
 
 	MLX5_ASSERT(rxq_data);
@@ -602,9 +584,7 @@
 		goto error;
 	}
 	/* Change queue state to ready. */
-	rq_attr.rq_state = MLX5_RQC_STATE_RST;
-	rq_attr.state = MLX5_RQC_STATE_RDY;
-	ret = mlx5_devx_cmd_modify_rq(tmpl->rq, &rq_attr);
+	ret = mlx5_devx_modify_rq(tmpl, true);
 	if (ret)
 		goto error;
 	rxq_data->cq_arm_sn = 0;